exodus/analysis_query/urls.py
from django.conf import settings
from django.urls import path

from . import views

app_name = 'analysis'
urlpatterns = [
    path('', views.AnalysisRequestListView.as_view(), name='index'),
    path('submit/', views.AnalysisRequestView.as_view(), name='submit'),
    path('<int:r_id>/', views.wait, name='wait'),
    path('<int:r_id>/json/', views.json, name='json'),
]

if settings.ALLOW_APK_UPLOAD:
    urlpatterns.append(path('upload/', views.upload_file, name='upload'))

exodus/exodus/urls.py
from django.conf import settings
from django.urls import include, path
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin

from . import views

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('api/', include('restful_api.urls')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

urlpatterns += i18n_patterns(
    path('', views.index, name='home'),
    path('analysis/', include('analysis_query.urls')),
    path('trackers/', include('trackers.urls')),
    path('reports/', include('reports.urls')),
    path('info/permissions/', views.permissions, name='permissions'),
    path('info/trackers/', views.trackers, name='trackers'),
    path('info/next/', views.next, name='next'),
    path('info/understand/', views.understand, name='understand'),
    path('info/organization/', views.organization, name='organization'),
)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# handler404 = 'exodus.views.page_not_found'
# handler500 = 'exodus.views.page_not_found'

exodus/reports/urls.py
from django.urls import path
from django.views.generic import RedirectView

from . import views

app_name = 'reports'
urlpatterns = [
    path('', views.index, name='index'),
    path('list/', views.get_reports, name='list'),
    path('<int:report_id>/', views.detail, name='detail'),
    path('<int:app_id>/icon/', views.get_app_icon, name='icon'),
    path('stats/', RedirectView.as_view(pattern_name='trackers:get_stats', permanent=False)),
    path('search/<handle>/', views.get_reports, name='search_by_handle'),
    path('<handle>/latest/', views.detail, name='get_latest'),
    path('<handle>/latest/icon/', views.get_app_icon, name='icon_by_handle'),
]

exodus/trackers/urls.py
from django.urls import path

from . import views

app_name = 'trackers'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:tracker_id>/', views.detail, name='detail'),
    path('stats/', views.get_stats, name='get_stats'),
    path('graph/', views.graph, name='graph'),
    path('details/', views.TrackersListView.as_view(), name='all_details'),
]

exodus/trackers/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models


class TrackerCategory(models.Model):
    name = models.CharField(max_length=200)

    def __str__(self):
        return self.name


class Tracker(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField(blank=True)
    creation_date = models.DateField(auto_now_add=True)
    code_signature = models.CharField(max_length=500, blank=True, default='')
    network_signature = models.CharField(max_length=500, blank=True, default='')
    website = models.URLField()
    category = models.ManyToManyField(TrackerCategory, blank=True)
    apps_number = models.IntegerField(default=0)
    apps_percent = models.IntegerField(default=0)

    def __str__(self):
        return self.name

    def get_color_class(self):
        if self.apps_percent >= 50:
            tracker_class = "danger"
        elif self.apps_percent >= 33:
            tracker_class = "alert"
        elif self.apps_percent >= 20:
            tracker_class = "warning"
        else:
            tracker_class = "info"
        return tracker_class


class DetectionRule(models.Model):
    tracker = models.ForeignKey(Tracker, on_delete=models.CASCADE)
    pattern = models.CharField(max_length=500)
    description = models.CharField(max_length=20000)

    def __str__(self):
        return self.pattern

exodus/trackers/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf import settings
from django.http.response import Http404
from django.shortcuts import render
from django.utils.translation import gettext_lazy as _
from django.views.generic import ListView

from reports.models import Application, Report
from trackers.models import Tracker


def index(request):
    filter = request.GET.get('filter', None)
    try:
        if filter == 'apps':
            trackers = Tracker.objects.order_by('-apps_number')
        else:
            trackers = Tracker.objects.order_by('name')
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))
    return render(request, 'trackers_list.html', {'trackers': trackers, 'filter': filter})


def detail(request, tracker_id):
    try:
        tracker = Tracker.objects.get(pk=tracker_id)
        # Add spaces aroung pipes for better rendering of signatures
        tracker.network_signature = tracker.network_signature.replace("|", " | ")
        tracker.code_signature = tracker.code_signature.replace("|", " | ")
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))

    reports = Report.objects.filter(found_trackers=tracker_id).order_by('-creation_date')[:settings.EX_PAGINATOR_COUNT]

    data_to_render = {
        'tracker': tracker,
        'reports': reports,
    }
    return render(request, 'tracker_details.html', data_to_render)


def get_stats(request):
    NB_OF_TRACKERS_TO_DISPLAY = 21

    trackers = Tracker.objects.order_by('-apps_number', 'name')[0:NB_OF_TRACKERS_TO_DISPLAY]
    if trackers.count() == 0:
        raise Http404(_("Tracker does not exist"))

    return render(request, 'stats_details.html', {'trackers': trackers})


def graph(request):
    try:
        g = "digraph {<br>"
        reports = Report.objects.order_by('-creation_date')
        u_t = Tracker.objects.distinct('name')
        for t in u_t:
            g += "t%s[group=\"tracker\", label=\"%s\"];<br>" % (t.id, t.name)
        u_a = Application.objects.distinct('handle')
        for a in u_a:
            g += "a%s[group=\"app\", label=\"%s\"];<br>" % (a.id, a.handle)

        for r in reports:
            for t in r.found_trackers.all():
                g += "\ta%s -> t%s;<br>" % (r.application.id, t.id)

        g += "<br>}"
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))
    return render(request, 'trackers_graph.html', {'g': g})


class TrackersListView(ListView):
    template_name = 'trackers_admin_list.html'
    context_object_name = 'trackers'

    def get_queryset(self):
        return Tracker.objects.order_by('-apps_number')

exodus/web/templates/base/base.html
{% load i18n %}
<!doctype html>
{% get_current_language as LANGUAGE_CODE %}
<html lang="{{ LANGUAGE_CODE }}">

<head>
  {% load static %}
  <link rel="stylesheet" href="{% static "css/bootstrap.min.css" %}">
  <link rel="stylesheet" href="{% static "css/exodus.css" %}">
  <link rel="shortcut icon" href="{% static "img/favicon.ico" %}">

  <script src="{% static "js/jquery.min.js" %}"></script>
  <script src="{% static "js/popper.min.js" %}"></script>
  <script src="{% static "js/bootstrap.min.js" %}"></script>
  <script src="{% static "js/handlebars.min.js" %}"></script>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>εxodus</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-dark bg-primary sticky-top mb-4">
    <div class="container">
      <a class="navbar-brand" data-toggle="tooltip" title="εxodus v1.20" href="{% url 'home' %}">
        <img src="/static/img/logo_purple_small.png" width="40" height="40" class="d-inline-block align-top"
          alt="exodus logo">
        <span class="h2">εxodus</span>
      </a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavDropdown"
        aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarNavDropdown">
        {% url 'home' as home %}
        {% url 'reports:index' as reports_url %}
        {% url 'trackers:index' as trackers_url %}
        {% url 'understand' as understand %}
        {% url 'organization' as organization %}
        <ul class="navbar-nav mr-auto mt-2 mt-lg-0">
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 {% if request.path == home %}active{% endif %}">
            <a class="nav-link " href="{{ home }}">{% trans "Home" %}</a>
          </li>
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 {% if request.path == reports_url %}active{% endif %}">
            <a class="nav-link " href="{{ reports_url }}">{% trans "Reports" %}</a>
          </li>
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 {% if request.path == trackers_url %}active{% endif %}">
            <a class="nav-link " href="{{ trackers_url }}">{% trans "Trackers" %}</a>
          </li>
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 {% if request.path == understand %}active{% endif %}">
            <a class="nav-link " href="{{ understand }}">{% trans "Better understand" %}</a>
          </li>
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 {% if request.path == organization %}active{% endif %}">
            <a class="nav-link " href="{{ organization }}">{% trans "The organization" %}</a>
          </li>
          {% if request.user.is_superuser %}
          <li class="nav-item mr-xl-3 ml-xl-3 mr-lg-2 ml-lg-2 dropdown">
            <a class="nav-link dropdown-toggle" href="#" id="adminDropdown" role="button" data-toggle="dropdown"
              aria-haspopup="true" aria-expanded="false">
              {% trans "Admin" %}
            </a>
            <div class="dropdown-menu" aria-labelledby="adminDropdown">
              <a class="dropdown-item" href="{% url 'admin:index' %}">{% trans "Index" %}</a>
              <a class="dropdown-item" href="{% url 'analysis:index' %}">{% trans "Analyzes" %}</a>
              <a class="dropdown-item" href="{% url 'trackers:all_details' %}">{% trans "Trackers" %}</a>
              <a class="dropdown-item text-danger" href="{% url 'admin:logout' %}">{% trans "Log out" %}</a>
            </div>
          </li>
          {% endif %}
        </ul>
        <form class="form-inline my-2 my-lg-0" action="{% url 'set_language' %}" method="post">
          <img class="mr-3 mr-lg-2 mr-xl-3" alt="language selector" src="{% static 'img/langue.svg' %}">
          {% csrf_token %}
          <input name="next" type="hidden" value="{{ request.get_full_path | slice:'3:' }}">
          <select class="custom-select custom-select-sm" name="language"
            onchange='if(this.value !=  "{{ LANGUAGE_CODE }}") { this.form.submit(); }'>
            {% get_current_language as LANGUAGE_CODE %}
            {% get_available_languages as LANGUAGES %}
            {% get_language_info_list for LANGUAGES as languages %}
            {% for language in languages %}
            <option value="{{ language.code }}" {% if language.code == LANGUAGE_CODE %}selected{% endif %}>
              {{ language.code }}
            </option>
            {% endfor %}
          </select>
        </form>
      </div>
    </div>
  </nav>

  <div class="container">
    {% block content %}
    {% endblock %}
  </div>
  <script>
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
  </script>
  {% block scripts %}
  {% endblock %}
</body>

</html>

exodus/web/templates/base/home.html
{% extends "base/base.html"%}
{% block content %}
{% load i18n %}
<div class="row justify-content-center mb-5 mt-5">
  <div class="col-xl-3 col-lg-3 col-md-3 col-sm-4 col-4 my-auto">
    <img src="/static/img/logo_purple_small.svg" class="mx-auto d-block img-fluid" alt="exodus logo">
  </div>
  <div class="col-xl-5 col-lg-5 col-md-8 col-sm-8 text-center my-auto">
    <h1 class="main-title">εxodus</h1>
    <h5><b>{% trans "The privacy audit platform for Android applications" %}</b></h5>
  </div>
</div>

{% include "snippets/reports_search.html" %}

<div class="row justify-content-center mb-5">
  <div class="col-lg-8 col-sm-12">
    <p class=mb-4>{% trans "εxodus analyzes Android applications in order to <b>list the embedded trackers.</b>" %}</p>
    <p class="mb-4">
      {% trans "A tracker is a piece of software <b>meant to collect data about you or your usages.</b> So, εxodus reports tell you what are the ingredients of the cake." %}
    </p>
    <p>{% trans "εxodus does not decompile applications, its analysis method is legal." %}</p>
  </div>
</div>

<div class="row justify-content-center mb-4">
  <div class="col-lg-8 col-sm-12">
    <h4>{% trans "Better understand" %}</h4>
    <p>{% trans "What is a tracker? And a permission? Are there any alternatives to protect yourself?" %}</p>
  </div>
</div>

<div class="row justify-content-center mb-5">
  <div class="col-lg-8 col-sm-12">
    <div class="row justify-content-center">
      <div class="col-8 col-sm-7 col-md-6 col-xl-5 text-center mb-4">
        <a href="{% url 'understand' %}" class="btn btn-primary btn-block">{% trans "Let's go!" %}</a>
      </div>
    </div>
  </div>
</div>

{% include "snippets/reports_links.html" %}

{% include "snippets/reports_search_tpl.html" %}
{% endblock %}

exodus/web/templates/base/next.html
{% extends "base/base.html" %}
{% load i18n %}
{% load static %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "What's next?" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-4">
    <p>
      {% trans "We know it is not easy to find alternatives in order to escape trackers within our apps. We prepared a list of tools and things you can do to better manage your privacy on your smartphone." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Consider how you use applications" %}</h4>
    <p>
      {% trans "When you wish to install an application or when an application asks for personal information, ask yourself the following questions:" %}
    </p>
    <ul>
      <li>{% trans "how many trackers does it contain and what permissions does it ask for?" %}</li>
      <li>{% trans "do I want or need to install it?" %}</li>
      <li>{% trans "do I want or need to give it what it asks me?" %}</li>
    </ul>
    <p>
      {% trans "It is up to you to decide but by taking into consideration your daily use, you can have a better control over your digital identity." %}
    </p>
    <p>
      {% trans "You could also contact the people who offer you the application if you consider it to be too intrusive and ask them some explanations on the presence of trackers and permission requests." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Favour free software" %}</h4>
    <p>
      {% trans "What is called 'free' software is software whose code (i.e. its recipe, or list of instructions) can be changed, copied, verified... and is thus transparent. A free software application might exist to replace an app that you already use but that may not respect your privacy." %}
    </p>
    <p class="text-center">
      <a target='_blank' rel='noreferrer' href='https://f-droid.org/'>
        <img src="{% static 'img/fdroid_logo.svg' %}" width="120" alt="F-droid logo">
      </a>
    </p>
    <p>
      {% trans "If you are an Android user, you can install <a target='_blank' rel='noreferrer' href='https://f-droid.org/'>F-Droid</a>. It is a free software store that can be used instead or in addition to the Google Play store. Do not hesitate to refer to the <a target='_blank' rel='noreferrer' href='https://f-droid.org/docs/'>F-Droid documentation</a> if needed. Be aware, however, that some F-Droid applications are not available in all languages." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Use the mobile website instead of the application" %}</h4>
    <p>
      {% trans "On a mobile device you don't necessary have to use applications: you can use mobile websites instead. One advantage in favour of the latter is the possibility to use  web browser add-ons, in the same way you can do it on your computer (e.g. uBlock Origin)." %}
    </p>
    <p class="text-center">
      <a style="text-decoration:none" target='_blank' rel='noreferrer' href='https://play.google.com/store/apps/details?id=org.mozilla.firefox'>
        <img src="{% static 'img/firefox_logo.png' %}" width="120" alt="Firefox logo">
      </a>
      <a target='_blank' rel='noreferrer' href='https://f-droid.org/packages/com.duckduckgo.mobile.android/'>
        <img src="{% static 'img/duckduckgo_logo.png' %}" width="120" alt="DuckDuckGo logo">
      </a>
    </p>
    <p>
      {% trans "If you want a browser experience that is more respectful of your privacy, you can use alternative browsers such as Mozilla Firefox or the DuckDuckGo Privacy Browser." %}
    </p>
    <p>
      {% trans "These browsers allow you to add your favorite websites on your home screen easily, just as an app (but lighter)." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Install an ad blocker" %}</h4>
    <p class="text-center">
      <a target='_blank' rel='noreferrer' href='https://blokada.org/'>
        <img src="{% static 'img/blokada_logo.png' %}" width="120" alt="Blokada logo">
      </a>
    </p>
    <p>
      {% trans "In all cases, Android smartphones allow you to install ad-blocking applications such as <a target='_blank' rel='noreferrer' href='https://blokada.org/'>Blokada</a>. You can install it from F-Droid (cf. above) or from their own website." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Discover alternatives" %}</h4>
    <p>
      {% trans "For broader recommendations, here are some resources you can dig in:" %}
      {% blocktrans %}
      <ul>
        <li><a target='_blank' rel='noreferrer' href='https://prism-break.org/en/categories/android/'>Prism Break</a></li>
        <li><a target='_blank' rel='noreferrer' href='https://ssd.eff.org/'>Surveillance Self-Defense by EFF</a></li>
        <li><a target='_blank' rel='noreferrer' href='https://www.privacytools.io/'>privacytools.io</a></li>
      </ul>
      {% endblocktrans %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "Remain curious!" %}</h4>
    <p>
      {% trans "In this area, what is true today may not necessarily be true tomorrow: tools might come and go, application policies can change, security breaches can be discovered..." %}
    </p>
    <p>
      {% trans "To this effect, you can attend workshops held by associations such as <a target='_blank' rel='noreferrer' href='https://en.wikipedia.org/wiki/CryptoParty'>cryptoparties</a> or other organizations like public libraries." %}
    </p>
    <p>
      {% trans "To stay up to date on these topics, you can find useful resources there:" %}
      {% blocktrans %}
      <ul>
        <li><a target='_blank' rel='noreferrer' href='https://www.eff.org/deeplinks'>EFF blog</a></li>
        <li><a target='_blank' rel='noreferrer' href='https://boingboing.net/'>The 'Boing Boing' blog</a></li>
      </ul>
      {% endblocktrans %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4 class="mt-2">{% trans "For advanced users" %}</h4>
    <p>
      {% trans "If you are into tweaking, <a target='_blank' rel='noreferrer' href='https://lineageos.org/'>Lineage OS</a> is an operating system based on Android; it can be used without Google services. It is possible to install it on your smartphone, provided your device is compatible." %}
    </p>
  </div>
</div>
{% endblock %}

exodus/web/templates/base/organization.html
{% extends "base/base.html" %}
{% load i18n %}
{% load static %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "The organization" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-5">
    <p class="text-center">
      <img src="{% static 'img/logo_purple_small.svg' %}" width="100">
    </p>
    <p>
      {% trans "Exodus Privacy is a non-profit organization led by hacktivists. Its purpose is to help people get a better understanding of the Android applications tracking issues." %}
    </p>
    <p class="text-center mb-4 mt-4">
      <a href="https://exodus-privacy.eu.org/{% if LANGUAGE_CODE == 'fr' %}fr{% endif %}" target="_blank" rel="noreferrer" class="btn btn-primary" style="width:300px">{% trans "Discover Exodus Privacy" %}</a>
    </p>
  </div>
  <div class="col-md-8 col-12 mb-5 mt-4">
    <h4>{% trans "Help us!" %}</h4>
    <p>
      {% trans "Exodus Privacy is an organization managed by volunteers. Whether you would like to draw, translate, code or create any kind of content, feel free: we welcome any help." %}
    </p>
    <p class="text-center mt-4">
      <a href="https://exodus-privacy.eu.org/{% if LANGUAGE_CODE == 'fr' %}fr{% else %}en{% endif %}/page/contribute/" target="_blank" rel="noreferrer" class="btn btn-outline-primary" style="width:300px">{% trans "How to contribute?" %}</a>
    </p>
  </div>
  <div class="col-md-8 col-12 mt-4 mb-4">
    <h4>{% trans "Contact us" %}</h4>
  </div>
</div>
<div class="row justify-content-sm-center">
  <div class="col-md-4 col-12 mb-4 text-center">
    <p><img src="{% static 'img/contact.svg' %}"></p>
    <p>contact@exodus-privacy.eu.org</p>
    <p><a href="mailto:contact@exodus-privacy.eu.org" class="btn btn-outline-primary" style="min-width:150px">{% trans "Contact us!" %}</a></p>
  </div>
  <div class="col-md-4 col-12 mb-4 text-center">
    <p><img src="{% static 'img/mastodon.svg' %}"></p>
    <p>@exodus</p>
    <p><a href="https://framapiaf.org/@exodus" target="_blank" rel="noreferrer" class="btn btn-outline-primary" style="min-width:150px">{% trans "Follow us!" %}</a></p>
  </div>
</div>
<div class="row justify-content-sm-center">
  <div class="col-md-4 col-12 mb-4 text-center">
    <p><img src="{% static 'img/twitter.svg' %}"></p>
    <p>@ExodusPrivacy</p>
    <p><a href="https://twitter.com/ExodusPrivacy" target="_blank" rel="noreferrer" class="btn btn-outline-primary" style="min-width:150px">{% trans "Follow us!" %}</a></p>
  </div>
  <div class="col-md-4 col-12 mb-4 text-center">
    <p><img src="{% static 'img/facebook.svg' %}"></p>
    <p>exodusprivacy</p>
    <p><a href="https://facebook.com/exodusprivacy" target="_blank" rel="noreferrer" class="btn btn-outline-primary" style="min-width:150px">{% trans "Follow us!" %}</a></p>
  </div>
</div>
{% endblock %}

exodus/web/templates/base/permissions.html
{% extends "base/base.html" %}
{% load i18n %}
{% load static %}
{% block content %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "Permissions" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-4">
    <p>
      {% trans "Permissions are access rights an app asks to access on your phone." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4>{% trans "What type of permissions?" %}</h4>
    <p>
      {% trans "They can concern various features or pieces of information, such as access to your geolocation, your contacts, your files, your microphone, vibrate function, camera and so on. Exodus Privacy analyses allow you to know, on a  per app basis, which permissions are asked." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4>{% trans "Why are some permissions indicated as dangerous?" %}</h4>
    <p>
      {% trans "Google defines <a target='_blank' rel='noreferrer' href='https://developer.android.com/guide/topics/permissions/overview'>danger levels for permissions</a>, which we report in our analyses." %}
    </p>
  </div>
  <div class="col-md-8 col-12 mb-4">
    <h4>{% trans "Do I have control over these permissions?" %}</h4>
    <p>
      {% trans "Depending on your smartphone and operating system, it is possible to restrain some of these permissions by going into your phone's settings." %}
    </p>
  </div>
</div>
{% endblock %}

exodus/web/templates/base/understand.html
{% extends "base/base.html" %}
{% load i18n %}
{% load static %}
{% block content %}
<div class="row justify-content-sm-center mb-4">
  <div class="col-md-8 col-12 text-center">
    <h1 class="main-title">
      {% trans "Better understand" %}
    </h1>
  </div>
</div>

<div class="row justify-content-sm-center mb-5">
  <div class="col-md-3 col-5 my-auto">
    <img class="img-fluid" src="{% static 'img/tracker.svg' %}" alt="trackers">
  </div>
  <div class="col-md-5 col-7">
    <div class="col-12">
      <h4>{% trans "Trackers " %}</h4>
      <p>
        {% trans "Know more about trackers and their impact on privacy" %}
      </p>
    </div>
    <div class="col-lg-6 col-md-8 col-12">
      <a href="{% url 'trackers' %}" class="btn btn-primary btn-block" style="min-width:150px">{% trans "Read the article" %}</a>
    </div>
  </div>
</div>

<div class="row justify-content-sm-center mb-5">
  <div class="col-md-5 col-7">
    <div class="col-12">
      <h4>{% trans "Permissions" %}</h4>
      <p>
        {% trans "What is permission and what are the privacy issues?" %}
      </p>
    </div>
    <div class="col-lg-6 col-md-8 col-12">
      <a href="{% url 'permissions' %}" class="btn btn-primary btn-block" style="min-width:150px">{% trans "Read the article" %}</a>
    </div>
  </div>
  <div class="col-md-3 col-5 my-auto">
    <img class="img-fluid" src="{% static 'img/permission.svg' %}" alt="permissions">
  </div>
</div>

<div class="row justify-content-sm-center mb-5">
  <div class="col-md-3 col-5 my-auto">
    <img class="img-fluid" src="{% static 'img/alternatives.png' %}" alt="alternatives">
  </div>
  <div class="col-md-5 col-7">
    <div class="col-12">
      <h4>{% trans "What's next?" %}</h4>
      <p>
        {% trans "A list of tools and things you can do to better manage your privacy on your smartphone" %}
      </p>
    </div>
    <div class="col-lg-6 col-md-8 col-12">
      <a href="{% url 'next' %}" class="btn btn-primary btn-block" style="min-width:150px">{% trans "Read the article" %}</a>
    </div>
  </div>
</div>
{% endblock %}